#include "mathstuff.hpp"

float sqlength(float x1, float x2 )
{
	return (x1*x1+x2*x2);
}

float sqdist_Point_to_Segment( float px, float py, float s0x, float s0y, float s1x, float s1y)
{
    float vx = s1x - s0x;
	float vy = s1y-s0y;

	float wx = px-s0x;
	float wy = py-s0y;

    float c1 = wx*vx+wy*vy;
    if ( c1 <= 0 )
        return sqlength(s0x-px,s0y-py);

    float c2 = vx*vx+vy*vy;
    if ( c2 <= c1 )
        return sqlength(s1x-px,s1y-py);

    float b = c1 / c2;
    float pbx = s0x + b * vx;
    float pby = s0y + b * vy;

    return sqlength(pbx-px,pby-py);
}
