#ifndef ICONS_HPP
#define ICONS_HPP

#include <iostream>
using namespace std;

#include "SDL/SDL.h"
#include "SDL/SDL_opengl.h"

class IconRenderer
{
public:
  void glIcon( GLint x, GLint y, int icon );
  IconRenderer();
  ~IconRenderer();
private:
  GLuint  base;                  /* Base Display List For The Font           */
  GLuint  icon_texture; /* Storage For Our Font Texture             */
  GLuint  avatarbase;
  GLuint  avatar_texture;
  void BuildIcon();
  void BuildAvatars();
};

#endif /* FONT_HPP */
