#ifndef TITLEPART_HPP
#define TITLEPART_HPP

#include "Engine/engine.hpp"
#include "engineinstance.hpp"
#include "widget.hpp"

class TitlePart_State {
public:

};

class TitlePart: public EnginePart {
public:
  void reset();
  TitlePart(const SubengineInterface* subengines, Global_Variables* p_global_variables);
  ~TitlePart();
protected:
  int input(const SDL_Event& event);
  int logic();
  void draw();
private:
	float theta;
   int curselected;
   int focus;//gui element focus
   TitlePart_State* state;
   Global_Variables* global_variables;
};

#endif /*  TITLEPART_HPP */
